<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Markup/__init__.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Markup/__init__.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Markup/__init__.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2006 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-string">&quot;&quot;&quot;Markup formatters.&quot;&quot;&quot;</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parametrized, Parameter</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.QualifiedName <span class="py-keyword">import</span> *</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> escape</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">import</span> re</span>
<a id="line14"></a><span class="lineno"> 14</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/Markup/Struct.html">Struct</a>:</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/Markup/Struct.html#__init__">__init__</a>(self, summary = <span class="py-string">''</span>, details = <span class="py-string">''</span>):</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">        self.summary = summary</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">        self.details = details</span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/Markup/Formatter.html">Formatter</a>(Parametrized):</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Interface class that takes a 'doc' annotation and formats its</span></span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line"><span class="py-string">    text. Markup-specific subclasses should provide appropriate format methods.&quot;&quot;&quot;</span></span>
<a id="line25"></a><span class="lineno"> 25</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/Markup/Formatter.html#init">init</a>(self, processor):</span>
<a id="line27"></a><span class="lineno"> 27</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">        self.processor = processor</span>
<a id="line29"></a><span class="lineno"> 29</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/Markup/Formatter.html#format">format</a>(self, decl, view):</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Format the declaration's documentation.</span></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line"><span class="py-string">        @param view the View to use for references and determining the correct</span></span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line"><span class="py-string">        relative filename.</span></span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line"><span class="py-string">        @param decl the declaration</span></span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line"><span class="py-string">        @returns Struct containing summary / details pair.</span></span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line"><span class="py-string">        &quot;&quot;&quot;</span></span>
<a id="line37"></a><span class="lineno"> 37</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">        doc = decl.annotations.get(<span class="py-string">'doc'</span>)</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">        text = doc <span class="py-keyword">and</span> escape(doc.text) <span class="py-keyword">or</span> <span class="py-string">''</span></span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">        m = re.match(<span class="py-string">r'(\s*[\w\W]*?\.)(\s|$)'</span>, text)</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">        summary = m <span class="py-keyword">and</span> m.group(1) <span class="py-keyword">or</span> <span class="py-string">''</span></span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">        <span class="py-keyword">return</span> Struct(summary, text)</span>
<a id="line43"></a><span class="lineno"> 43</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/Markup/Formatter.html#lookup_symbol">lookup_symbol</a>(self, symbol, scope):</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Given a symbol and a scope, returns an URL.</span></span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line"><span class="py-string">        Various methods are tried to resolve the symbol. First the</span></span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line"><span class="py-string">        parameters are taken off, then we try to split the symbol using '.' or</span></span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line"><span class="py-string">        '::'. The params are added back, and then we try to match this scoped</span></span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line"><span class="py-string">        name against the current scope. If that fails, then we recursively try</span></span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line"><span class="py-string">        enclosing scopes.</span></span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line"><span class="py-string">        &quot;&quot;&quot;</span></span>
<a id="line52"></a><span class="lineno"> 52</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">        <span class="py-comment"># Remove params</span></span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">        index = symbol.find(<span class="py-string">'('</span>)</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">        <span class="py-keyword">if</span> index &gt;= 0:</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">            params = symbol[index:]</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">            symbol = symbol[:index]</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">            params = <span class="py-string">''</span></span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">        <span class="py-keyword">if</span> <span class="py-string">'.'</span> <span class="py-keyword">in</span> symbol:</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">            symbol = QualifiedPythonName(symbol.split(<span class="py-string">'.'</span>))</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">            symbol = QualifiedCxxName(symbol.split(<span class="py-string">'::'</span>))</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">        <span class="py-comment"># Add params back</span></span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">        symbol = symbol[:-1] + (symbol[-1] + params,)</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">        <span class="py-comment"># Find in all scopes</span></span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">        <span class="py-keyword">while</span> 1:</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">            entry = self._lookup_symbol_in(symbol, scope)</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">            <span class="py-keyword">if</span> entry:</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">                <span class="py-keyword">return</span> entry.link</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">            <span class="py-keyword">if</span> len(scope) == 0: <span class="py-keyword">break</span></span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">            scope = scope[:-1]</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">        <span class="py-comment"># Not found</span></span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">        <span class="py-keyword">return</span> None</span>
<a id="line75"></a><span class="lineno"> 75</span>
<a id="line76"></a><span class="lineno"> 76</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/Markup/Formatter.html#_lookup_symbol_in">_lookup_symbol_in</a>(self, symbol, scope):</span>
<a id="line78"></a><span class="lineno"> 78</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">        paren = symbol[-1].find(<span class="py-string">'('</span>)</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">        <span class="py-keyword">if</span> paren != -1:</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">            <span class="py-keyword">return</span> self._find_method_entry(symbol[-1], scope + symbol[:-1])</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">            <span class="py-keyword">return</span> self.processor.toc.lookup(scope + symbol)</span>
<a id="line84"></a><span class="lineno"> 84</span>
<a id="line85"></a><span class="lineno"> 85</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/Markup/Formatter.html#_find_method_entry">_find_method_entry</a>(self, name, scope):</span>
<a id="line87"></a><span class="lineno"> 87</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">        <span class="py-keyword">try</span>:</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">            scope = self.processor.ir.asg.types[scope]</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">        <span class="py-keyword">except</span> KeyError:</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">            <span class="py-keyword">return</span> None</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> isinstance(scope, ASG.DeclaredTypeId):</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">            <span class="py-keyword">return</span> None</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">        scope = scope.declaration</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> isinstance(scope, ASG.Scope):</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">            <span class="py-keyword">return</span> None</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">        <span class="py-comment"># For now disregard parameters during lookup.</span></span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">        name = name[:name.find(<span class="py-string">'('</span>)]</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> scope.declarations:</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">            <span class="py-keyword">if</span> isinstance(d, ASG.Function):</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">                <span class="py-keyword">if</span> d.real_name[-1] == name:</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">                    <span class="py-keyword">return</span> self.processor.toc.lookup(d.name)</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">        <span class="py-keyword">return</span> None</span>
<a id="line104"></a><span class="lineno">104</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:12 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
